<?php
namespace Teknisa\CUS\Services;

class ServicosPorGrupo {

	protected $entityManager;

	public function __construct($entityManager) {
		$this->entityManager = $entityManager;
	}

	public function retornaServicosPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupserv, $concat = true, $cdgrupfili = null) {
		$servicosRetorno = $this->servicoPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupserv, $cdgrupfili);
		if($concat){
		    return $this->retornaServicosConcatenados($servicosRetorno);
		} else {
		    return $servicosRetorno;
		}
	}
 
    public function retornaServicosConcatenados($servicos) {

        $newArray = array();

        foreach ($servicos as $servico) {

            $newArray[] = $servico['CDSERVFILI'];
        }

        return implode("_", $newArray);
    }

    public function servicoPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupserv, $cdgrupfili = null) {
        $sql = <<<SQL
			SELECT S.CDFILIAL, S.CDSERVFILI, S.NMSERVICO, S.NRORG, SUBSTR(S.CDFILIAL || S.CDSERVFILI, 1, 9) AS FILISERV FROM SERVICO    S, FILIOPER   F WHERE ( ( S.CDFILIAL = :CDFILIAL AND (:CDGRUPFILI IS NULL OR :CDGRUPFILI = 'T')) OR ( :CDFILIAL = 'T' AND (:CDGRUPFILI IS NULL OR :CDGRUPFILI = 'T') ) OR ( (:CDGRUPFILI IS NOT NULL AND :CDGRUPFILI <> 'T') AND S.CDFILIAL IN ( SELECT CDFILIAL FROM FILGRUPFILI WHERE CDGRUPFILI = :CDGRUPFILI ) ) OR (:CDFILIAL IS NOT NULL AND :CDFILIAL <> 'T' AND VALOR_NA_LISTA(S.CDFILIAL, :CDFILIAL) <> 0)) AND ( ( VALOR_NA_LISTA(S.CDGRUPSERV, :CDGRUPSERV) <> 0 ) OR ( :CDGRUPSERV = 'T' ) ) AND ( F.CDOPERADOR = :CDOPERADOR ) AND ( F.CDFILIAL = S.CDFILIAL ) ORDER BY S.CDFILIAL, NLSSORT(S.CDSERVFILI, 'NLS_SORT=BINARY_AI')
SQL;
        $params = array(
            'NRORG'         =>  $nrorg,
            'CDFILIAL'      =>  $cdfilial,
            'CDOPERADOR'    =>  $cdoperador,
            'CDGRUPSERV'    =>  $cdgrupserv,
            'CDGRUPFILI'    =>  $cdgrupfili
        );
        try{
            $conn = $this->entityManager->getConnection();
            return $conn->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}